---
title: "Meet the Team"
slug: "team"
excerpt: ""
hidden: false
createdAt: "2022-08-15T22:36:48.659Z"
updatedAt: "2022-09-08T00:28:12.217Z"
---
Pants open source project has had many team members in over a decade. The current team is comprised of elected Contributors and Maintainers, who are nominated based on [criteria](doc:the-pants-community#how-is-the-community-structured) including demonstrated commitment to the project and a track record of contributions to the project and community.

> 📘 Interested in joining the Pants team?
>
> Welcome, future colleague! Learn more about the team's composition and eligibility criteria on the [Pants Community](doc:the-pants-community) page, then post in the #development channel of the [community Slack](doc:getting-started) to express interest in joining the team. We love opportunity to usher in new teammates, and are happy to offer mentorship support to community members who request it and have a track record of commitment to the long-term vitality of the project.

## Current Team

### Maintainers
-----------

| **NAME**                   | **PROUDEST CONTRIBUTION**                                                                             |
| -------------------------- | ----------------------------------------------------------------------------------------------------- |
| **A. Alonso Dominguez**    | "Adding support for Helm and working on extending it to support managing deployments"                 |
| **Alexey Tereshenkov**     | "Adding yapf formatter support and writing blog posts about Pants"                                    |
| **Andreas Stenius**        | "Adding Docker support"                                                                               |
| **Benjy Weinberger**       | "The options system — unifying our flags, config and env vars into a coherent, extensible framework." |
| **Carina C. Zona**         | "Developing the #welcome channel on Pants community chat"                                             |
| **Christopher Neugebauer** | Adding multi-architecture Mac support for Apple Silicon (M1s)                                         |
| **Daniel Wagner-Hall**     | Laid the foundation for remote execution                                                              |
| **Danny McClanahan**       | Implemented bounded runtime polymorphism with union rules and improved plugin UX with async/await     |
| **Eric Arellano**          | "Migrating Pants to Python 3 for my internship project"                                               |
| **Henry Fuller**           | "Working on replacing watchman with a kernel based file watcher in the V2 engine"                     |
| **John Sirois**            |                                                                                                       |
| **Josh Reed**          | "Remains continually willing to bikeshed about design decisions on the Pants Slack"                     |
| **Joshua Cannon**          | "I'm proud and thankful my voice can and is being used to shape Pants inside and out"                 |
| **Kris Wilson**            | "Helping lay the foundation for the v2 engine and realizing the power of Rust + Python for perf".     |
| **Patrick Lawson**         | Formalized targets, BUILD files, and fingerprinting in v.1                                            |
| **Stu Hood**               | Helping to push the v2 engine forward, which eventually turned into Pants 2.0.                        |
| **Tom Dyas**               | Adding the Golang backend and getting remote execution to work with more servers.                     |
| **Yi Cheng**               | Adding coursier integration to v.1                                                                    |

### Contributors
------------

| **NAME**               | **PROUDEST CONTRIBUTION**                                                                               |
| ---------------------- | ------------------------------------------------------------------------------------------------------- |
| **Chris Williams**     |                                                                                                         |
| **Dan Moran**          | "Enabling automatic usage of `pytest-xdist` in `./pants test`"                                          |
| **Doron Somech**       | "Improving Scala dependency inference to support our codebase"                                                                                                        |
| **Jacob Floyd**        | Gave the idea for skip_flake8 et al, which grew into a flagship feature: incremental adoption           |
| **Jonas Stendahl**     | "Adding formatting and linting support for Protobuf"                                                                                                        |
| **Marcelo Trylesinski**            | "Improving onboarding experience"     |
| **Nick Grisafi**       | "Participating in podcasts with maintainers (Eric and Josh) on developer experience and Pants!"         |
| **Raúl Cuza**          | "The first time I was able to help someone else with pants on the Slack <https://pantsbuild.slack.com>." |
| **Rhys Madigan**       | "Making unit test run times easier to understand"                                                       |
| **Suresh Joshi (SJ)**  | "Writing a post on the Pants Blog about my experimental PyOxidizer plugin"                              |
| **Tansy Arron-Walker** | "Writing my first task in the new engine was really exciting!"                                          |
| **Thales Menato**      | "Making sure Pants can run even under heavily secured work environments!"                                                                                                        |

***

## Emeritus

When team members retire from the team in good standing, they are designated emeritus. We are grateful for the many past contributons by our emeritus team members, whose collective work created the strong foundations that modern Pants stands on. We are honored to have had the opportunity to collaborate with them as teammates.

### Maintainers Emeritus
--------------------

| **NAME**              | **PROUDEST CONTRIBUTION**                                                           |
| --------------------- | ----------------------------------------------------------------------------------- |
| **Andy Reitz**        |                                                                                     |
| **Borja Lorente**     | "Polished several components, including the v1 daemon and the v2 CLI UX"            |
| **Chris Heisterkamp** | Revamped the JUnit Test runner in v.1                                               |
| **Chris Livingston**  | Added support to v.1 for 3rd party resolution of native (C/C++) dependencies        |
| **David Taylor**      |                                                                                     |
| **David Turner**      |                                                                                     |
| **Dorothy Ordogh**    |                                                                                     |
| **Eric Ayers**        |                                                                                     |
| **Fedor Korotkov**    |                                                                                     |
| **Ity Kaul**          |                                                                                     |
| **Garrett Malmquist** | Worked on codegen in v.1                                                            |
| **Greg Shuflin**      | "Being a part of the team effort to get Pants 2.0 shipped"                          |
| **Larry Hosken**      |                                                                                     |
| **Mateo Rodriguez**   | Added Android support to v.1                                                        |
| **Matt Olsen**        | Added infrastructure Scala to v.1                                                   |
| **Nora Howard**       | "Parallelized JVM compilation in v.1 and developed one of the v2 engine prototypes" |
| **Peiyu Wang**        |                                                                                     |
| **Pierre Chevalier**  | Kickstarting adoption of the Black linter                                           |
| **Tejal Desai**       |                                                                                     |
| **Travis Crawford**   |                                                                                     |
| **Yujie Chen**        |                                                                                     |

### Contributors Emeritus
---------------------

| **NAME**             | **PROUDEST CONTRIBUTION**                                               |
| -------------------- | ----------------------------------------------------------------------- |
| **Liam Wilson**      | Added Poetry support                                                    |
| **Mathieu Sabourin** | "Helped with the Python 3 migration and fixed some bugs along the way." |